# STM32F769I-EVAL Evaluation board

## Overview

The evaluation  kit enables a wide range of use cases taking advantage of
premium graphics, audio, multi-sensor support, WVGA color display,
security, memory extension and connectivity features. An embedded
ST-LINK/V2-1 debugger/programmer is included; specialized add-on boards
can be connected thanks to the **expansion** connectors.

## Getting started

- [User manual](https://www.st.com/resource/en/user_manual/um2035-evaluation-board-with-stm32f769ni-mcu-stmicroelectronics.pdf)

### ST-LINK driver installation and firmware upgrade (on Microsoft Windows)

1. Download the latest [ST-LINK driver](https://www.st.com/en/development-tools/stsw-link009.html).
2. Extract the archive and run `dpinst_amd64.exe`. Follow the displayed instructions.
3. Download the latest [ST-LINK firmware upgrade](https://www.st.com/en/development-tools/stsw-link007.html).
4. Extract the archive and run the `ST-LinkUpgrade.exe` program.
5. Connect the board to your PC using a USB cable and wait until the USB enumeration is completed.
6. In the **ST-Link Upgrade** program, press the **Device Connect** button.
7. When the ST-LINK driver is correctly installed, the current ST-LINK version is displayed.
8. Press the **Yes >>>>** button to start the firmware upgrade process.

## Technical reference

- [STM32F769NI microcontroller](https://www.st.com/en/microcontrollers-microprocessors/stm32f769ni.html)
- [STM32F769I-EVAL board](https://www.st.com/en/evaluation-tools/stm32f769i-eval.html)
- [User manual](https://www.st.com/resource/en/user_manual/um2035-evaluation-board-with-stm32f769ni-mcu-stmicroelectronics.pdf)
- [Data brief](https://www.st.com/resource/en/data_brief/stm32f769i-eval.pdf)
- [Schematic](https://www.st.com/resource/en/schematic_pack/stm32f7x9i-eval_sch.zip)
